'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildAll = exports.build = undefined;

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var build = exports.build = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(id, verbose) {
    var bitId, consumer, component, result, distFilePaths;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            bitId = (_bitId || _load_bitId()).BitId.parse(id);
            _context.next = 3;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 3:
            consumer = _context.sent;
            _context.next = 6;
            return consumer.loadComponent(bitId);

          case 6:
            component = _context.sent;
            _context.next = 9;
            return component.build({ scope: consumer.scope, consumer, verbose });

          case 9:
            result = _context.sent;

            if (!(result === null)) {
              _context.next = 12;
              break;
            }

            return _context.abrupt('return', null);

          case 12:
            _context.next = 14;
            return component.writeDists(consumer);

          case 14:
            distFilePaths = _context.sent;

            consumer.bitMap.addMainDistFileToComponent(component.id, distFilePaths);
            _context.next = 18;
            return consumer.bitMap.write();

          case 18:
            return _context.abrupt('return', distFilePaths);

          case 19:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function build(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var buildAllResults = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(components, consumer, verbose) {
    var _this = this;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt('return', components.map(function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(component) {
                var result, bitId, buildResults;
                return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return component.build({ scope: consumer.scope, consumer, verbose, ensureCompiler: false });

                      case 2:
                        result = _context2.sent;
                        bitId = new (_bitId || _load_bitId()).BitId({ box: component.box, name: component.name });

                        if (!(result === null)) {
                          _context2.next = 6;
                          break;
                        }

                        return _context2.abrupt('return', { component: bitId.toString(), buildResults: null });

                      case 6:
                        _context2.next = 8;
                        return component.writeDists(consumer);

                      case 8:
                        buildResults = _context2.sent;
                        return _context2.abrupt('return', { component: bitId.toString(), buildResults });

                      case 10:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, _this);
              }));

              return function (_x6) {
                return _ref3.apply(this, arguments);
              };
            }()));

          case 1:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function buildAllResults(_x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

var buildAll = exports.buildAll = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(verbose) {
    var consumer, componentsList, newAndModifiedComponents, compilerIds, authoredAndImported, authoredAndImportedIds, _ref5, components, buildAllP, allComponents, componentsObj;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context4.sent;
            componentsList = new (_componentsList || _load_componentsList()).default(consumer);

            (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_LOADING_COMPONENTS);

            // Install all compilers for new and modified components
            // TODO: we should filter the authoredAndImported to get only the modified, it will be better in terms of performenct
            _context4.next = 7;
            return componentsList.newAndModifiedComponents();

          case 7:
            newAndModifiedComponents = _context4.sent;
            compilerIds = newAndModifiedComponents.map(function (c) {
              return c.compilerId;
            });

            (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_ENVIRONMENT);
            _context4.next = 12;
            return consumer.scope.installEnvironment({ ids: compilerIds, verbose });

          case 12:
            authoredAndImported = consumer.bitMap.getAllComponents([(_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED, (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED]);

            if (!(_ramda || _load_ramda()).default.isEmpty(authoredAndImported)) {
              _context4.next = 15;
              break;
            }

            return _context4.abrupt('return', Promise.reject('nothing to build'));

          case 15:
            authoredAndImportedIds = Object.keys(authoredAndImported).map(function (id) {
              return (_bitId || _load_bitId()).BitId.parse(id);
            });
            _context4.next = 18;
            return consumer.loadComponents(authoredAndImportedIds);

          case 18:
            _ref5 = _context4.sent;
            components = _ref5.components;
            _context4.next = 22;
            return buildAllResults(components, consumer, verbose);

          case 22:
            buildAllP = _context4.sent;
            _context4.next = 25;
            return Promise.all(buildAllP);

          case 25:
            allComponents = _context4.sent;
            componentsObj = {};

            allComponents.forEach(function (component) {
              componentsObj[component.component] = component.buildResults;
            });
            _context4.next = 30;
            return consumer.bitMap.write();

          case 30:
            return _context4.abrupt('return', componentsObj);

          case 31:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function buildAll(_x7) {
    return _ref4.apply(this, arguments);
  };
}();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../../cli/loader'));
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../../../consumer/component/components-list'));
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../../cli/loader/loader-messages');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }
//# sourceMappingURL=build.js.map